#!/usr/bin/perl

$E_MAXAMP = 400;
$E_MIN = 0 ;
$E_LEN = 512 ;

# Random walk
if ($ARGV[0] eq rw) {
   $r = int ($E_MAXAMP / 2) ;
   for ($i = 0 ; $i < $E_LEN ; $i++) {
      if (int (rand(2)) == 1 ) { $r = int ($r+(rand(10))) ;}
      else                     { $r = int ($r-(rand(9))) ;}
      $r = $E_MAXAMP if ($r > $E_MAXAMP) ;
      $r =         0 if ($r < 0) ;
      print "$r\n" ;
   }
}


#Damped sine
elsif ($ARGV[0] eq ds) {
   $offset = int ($E_MAXAMP / 2) ;
   $A = 200 ;
   for ($i = 0 ; $i < $E_LEN ; $i++) {
      $y = int ($A * sin($i/20)) + $offset ;
      $A = $A - 0.4 ;
      print "$y\n" ;
   }
}


#twosimilarpeaks
elsif ($ARGV[0] eq tp) {
   @A=() ;
   $offset = int ($E_MAXAMP / 2) ;
   $A = 200 ;
   for ($i = 0 ; $i < $E_LEN/2 ; $i++) {
      $y = int (-$A * cos($i/20)) + $offset ;
      $A = $A - 0.8 ;
      push (@A,$y) ;
      print "$y\n" ;
   }
   foreach $y (reverse @A) {
      print "$y\n" ;
   }
}

#twodissimilarpeaks
elsif ($ARGV[0] eq td) {
   $thismax= 0 ;
   $offset = int ($E_MAXAMP / 2) ;
   $A = 200 ;
   for ($i = 0 ; $i < $E_LEN/2 ; $i++) {
      $y = int (-$A * cos($i/20)) + $offset ;
      $A = $A - 0.8 ;
      print "$y\n" ;
      $thismax=$y if ($y >$thismax) ;
   }
   for ($i = $i ; $i < (int(($E_LEN/2)+(($E_LEN/2)/3))) ; $i++) {
      print "$y\n" ;
      $y = $y-1;
   }
   $diff= $thismax - $y ;
   $step= $diff/(int(($E_LEN-$i)/2));
   $end = $i + int(($E_LEN-$i)/2) ;
   $b = $y ;
   $x = 1 ;
   for ($i = $i ; $i < $end ; $i++) {
      $y = $b + $step * $x;
      $why= int($y) ; 
      print "$why\n" ;
      $x++ ;
   }

   $step= $y/(int(($E_LEN-$i)));
   $x = 1 ;
   for ($i = $i ; $i < $E_LEN ; $i++) {
      $y = $thismax - $step * $x;
      $why= int($y) ; 
      print "$why\n" ;
      $x++ ;
   }
}

#user
else {
}


